<?php
/**
* dolphin. Collection of useful PHP skeletons.
* Copyright (C) 2013-2020  Johannes 'Banana' Keßler
*
* https://www.bananas-playground.net
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the COMMON DEVELOPMENT AND DISTRIBUTION LICENSE
*
* You should have received a copy of the
* COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
* along with this program.  If not, see http://www.sun.com/cddl/cddl.html
*/

/**
 * Class TitlePrincipals
 * Import the data from imdb dataset title.principals.tsv
 */
class TitlePrincipals extends TSVImport {
    /**
    * @inheritDoc
    */
    public function setup() {
        $this->_db_table_name = 'title_principals';
        $this->_db_table_crate_str = "CREATE TABLE `".$this->_db_table_name."` (
`tconst` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
`ordering` int NOT NULL,
`nconst` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
`category` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
`job` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
`characters` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
UNIQUE KEY `tconst` (`tconst`,`ordering`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_bin";
    }

    /**
    * @inheritDoc
    */
    public function queryValuePart($data) {
        $ret = '';

        if(!empty($data)) {
            if(!isset($data[5])) {
                return $ret;
            }

            $ret .= "(
                '".$this->_DB->real_escape_string($data[0])."',
                '".$this->_DB->real_escape_string($data[1])."',
                '".$this->_DB->real_escape_string($data[2])."',
                '".$this->_DB->real_escape_string($data[3])."',
                '".$this->_DB->real_escape_string($data[4])."',
                '".$this->_DB->real_escape_string($data[5])."'
            )";
        }

        return $ret;
    }
}
